#include <allegro.h>
#include <alfont.h>
#include <list>
#include "controls.h"
#include "main.h"
#include "globals.h"
#include "units.h"
#include "items.h"
#include "map.h"

using namespace std;

CMenu :: CMenu()
{
    iState = ATTACK_STATE;  
    h = SCREEN_H / 10;  
}    

void CMenu :: DoDraw()
{
    set_trans_blender(0,0,255,200);
    BITMAP* Mnu = create_bitmap(SCREEN_W,h);
    rectfill(Mnu,0,0,SCREEN_W,h,makecol(0,0,255));
    draw_trans_sprite(Offscreen,Mnu,0,0);
    destroy_bitmap(Mnu); 
    rect(Offscreen,20,20,100,40,iState==ATTACK_STATE?makecol(255,255,147):0);
    rect(Offscreen,120,20,200,40,iState==TALK_STATE?makecol(255,255,147):0);
    rect(Offscreen,SCREEN_W - 100,20,SCREEN_W - 20,40,0);
    rect(Offscreen,SCREEN_W - 240,20,SCREEN_W - 120,30,0);
    rectfill(Offscreen,SCREEN_W - 239,21,SCREEN_W - 241 + Player->HP * 120 / PLAYER_MAX_HP,29,makecol(174,255,255));
    alfont_set_font_size(MyFont, 14);
    alfont_textout(Offscreen,MyFont,"Energy:",SCREEN_W - 310,18,makecol(174,255,255));
    alfont_set_font_size(MyFont, 16);
    if ((mouse_x >= 20) && (mouse_x <= 100) && (mouse_y >= 20) && (mouse_y <= 40))
    {
         rectfill(Offscreen,21,21,99,39,makecol(255,255,174));
         alfont_textout(Offscreen,MyFont,"Attack",22,24,0); 
         if (mouse_b & 1) iState = ATTACK_STATE;
    }    
    else
    {
         rectfill(Offscreen,21,21,99,39,makecol(0,0,193));
         alfont_textout(Offscreen,MyFont,"Attack",22,24,makecol(128,255,255)); 
    }    
    if ((mouse_x >= 120) && (mouse_x <= 200) && (mouse_y >= 20) && (mouse_y <= 40))
    {         
         rectfill(Offscreen,121,21,199,39,makecol(255,255,174));
         alfont_textout(Offscreen,MyFont,"Talk",129,24,0); 
         if (mouse_b & 1) iState = TALK_STATE;
    }    
    else
    {
         rectfill(Offscreen,121,21,199,39,makecol(0,0,193));
         alfont_textout(Offscreen,MyFont,"Talk",129,24,makecol(128,255,255)); 
    }    
    if ((mouse_x >= SCREEN_W - 100) && (mouse_x <= SCREEN_W - 20) && (mouse_y >= 20) && (mouse_y <= 40))
    {
         rectfill(Offscreen,SCREEN_W - 99,21,SCREEN_W - 21,39,makecol(255,255,174));
         alfont_textout(Offscreen,MyFont,"Exit",SCREEN_W - 85,24,0); 
         if (mouse_b & 1)   // exit game
             bPlaying = false;
    }    
    else
    {
         rectfill(Offscreen,SCREEN_W - 99,21,SCREEN_W - 21,39,makecol(0,0,193));     
         alfont_textout(Offscreen,MyFont,"Exit",SCREEN_W - 85,24,makecol(128,255,255)); 
    }            
    
}    

void MouseActions()
{        
    if (mouse_y > Menu->h)   // only if we click outside the menu
    {        
        if (mouse_b & 2)    // right click
        {
            CameraSpeed = PLAYER_STEP;
            bool bSomethingsUnder = false;  // we clicked on something
            list<CUnit*>::iterator i = Monsters.begin();
            while ( (!bSomethingsUnder) && (i != Monsters.end()) )
            {
                if ( ((*i)->x - Map->iGlobalX <= mouse_x) && ((*i)->x + (*i)->w - Map->iGlobalX >= mouse_x) &&
                     ((*i)->y - Map->iGlobalY <= mouse_y) && ((*i)->y + (*i)->h - Map->iGlobalY >= mouse_y) )
                {
                    if ((*i)->bAlive) bSomethingsUnder = true;
                }
                else
                {
                    i++;
                }        
            }    
            if (bSomethingsUnder)    // we have found something!
            {
                switch (Menu->iState)
                {
                    case ATTACK_STATE: Player->iState = ATTACK;
                                       Player->iGoX = (*i)->x;
                                       Player->iGoY = (*i)->y;
                                       break;
                    case TALK_STATE: Player->iState = TALK;
                                     Player->Talker = *i;
                                     Player->iGoX = (*i)->x;
                                     Player->iGoY = (*i)->y;
                                     break;                                     
                }    
            }
            else    // there are no monsters clicked upon
            {
                list<CItem*>::iterator j = Items.begin();
                while ( (!bSomethingsUnder) && (j != Items.end()) )
                {
                    if ( ((*j)->x <= mouse_x) && ((*j)->x + (*j)->w >= mouse_x) &&
                         ((*j)->y <= mouse_y) && ((*j)->y + (*j)->h >= mouse_y) )
                    {
                         bSomethingsUnder = true;
                    }
                    else
                    {
                         j++;
                    }   
                }    
                
                if (!bSomethingsUnder)   // we haven't clicked on anything
                {
                    Player->iState = MOVE;
                    Player->iGoX = mouse_x + Map->iGlobalX - (SQUARE_WIDTH >> 1);
                    Player->iGoY = mouse_y + Map->iGlobalY - (SQUARE_HEIGHT >> 1);
                }
                else
                {
                }         
            }        
        }    
    }    
}    
