/*
***************************************************
*                                                 *
*               SPECIAL ADDITIONS                 *
*                                                 *
***************************************************

This is where I'll put the effects the game uses, as well as
additional stuff to meet the TINS requirements (such as a lock).

Author: Gajo Csaba
Date: 26 Feb, 2005
Version: 0.1
*/

#ifndef _special_h
#define _special_h

class BITMAP;

void Mosaic(BITMAP* Pic, int &iCounter);   // mosaic effect
void FallAppart(BITMAP* Pic, int &iCounter);   // fall appart effect

class CTableGame
{
    protected:
        int table[3][3];        
        void DrawTable();
        void UserAction();
        bool bComputersTurn;
    public:
        bool Victory;
        CTableGame();
        ~CTableGame();
        bool XO();   
};

class CBookReader
{
    private:
        int CountDown;
        int iInternalClock;
    public:
        CBookReader(int interval);
        bool ReadTheBook(volatile int &mtime);
}; 

class CMainMenu
{
    private:
        int iMouseClickCounter;
        bool bDisplayExitMessage;
    protected:
        BITMAP* SplashScreen;        
        int iInternalClock;
        int iCounter;
        bool bExplained;
    public:
        int iState;
        CMainMenu(int interval);
        ~CMainMenu();
        int MenuResult(volatile int &mtime);
};       

#endif
